varying vec3 vpos, norm, lvec, spot_dir;

varying vec4 shadow_tc;
uniform sampler2DShadow shadowmap;

void main()
{
	float stex = shadow2DProj(shadowmap, shadow_tc).x;

	vec3 n = normalize(norm);
	vec3 l = normalize(lvec);
	vec3 v = -normalize(vpos);
	vec3 h = normalize(l + v);
	vec3 sdir = -normalize(spot_dir);

	float ndotl = max(0.0, dot(n, l));
	float ndoth = max(0.0, dot(n, h));

	vec4 camb = gl_LightModel.ambient * gl_FrontMaterial.ambient;
	vec4 cdif = ndotl * gl_FrontMaterial.diffuse;
	vec4 cspec = pow(ndoth, gl_FrontMaterial.shininess) * gl_FrontMaterial.specular;

	float spot_dot = max(0.0, dot(sdir, l));

	/*
	float spot_att;
	if(spot_dot < gl_LightSource[0].spotCosCutoff) {
		spot_att = 0.0;
	} else {
		spot_att = pow(spot_dot, gl_LightSource[0].spotExponent);
	}
	*/

	float spot_outer = radians(gl_LightSource[0].spotCutoff);
	float spot_inner = radians(gl_LightSource[0].spotCutoff - gl_LightSource[0].spotExponent);

	float spot_angle = acos(spot_dot);
	float spot_att = 1.0 - smoothstep(spot_inner, spot_outer, spot_angle);

	vec4 col = camb + spot_att * (cdif * stex + cspec);

	gl_FragColor = vec4(col.xyz, 1.0);
}
