varying vec3 vpos, norm, lvec, spot_dir;

varying vec4 shadow_tc;

void main()
{
	vpos = (gl_ModelViewMatrix * gl_Vertex).xyz;
	norm = (gl_NormalMatrix * gl_Normal).xyz;

	lvec = gl_LightSource[0].position.xyz - vpos;
	spot_dir = gl_LightSource[0].spotDirection;

	mat4 offmat = mat4(0.5, 0.0, 0.0, 0.0,
						0.0, 0.5, 0.0, 0.0,
						0.0, 0.0, 0.5, 0.0,
						0.5, 0.5, 0.5, 1.0);
	mat4 tex_matrix = offmat * gl_TextureMatrix[0];

	shadow_tc = tex_matrix * gl_Vertex;
	shadow_tc = shadow_tc / shadow_tc.w;

	gl_Position = ftransform();
}
